<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <script type="text/javascript">
            function setCaretToEnd(e) {
                var control = $(e.source.id);
                if (control.createTextRange) {
                    var range = control.createTextRange();
                    range.collapse(false);
                    range.select();
                } else if (control.setSelectionRange) {
                    control.focus();
                    var length = control.value.length;
                    control.setSelectionRange(length, length);
                }
                control.selectionStart = control.selectionEnd = control.value.length;
                var veld = document
                        .getElementById("rulesForm:rules:ruleFilterinput");
                veld.focus();
            }

        </script>
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="ruleCoverage"/>
            <ui:param name="controllerName" value="#{ruleLinkManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.RulesFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <h:form id="filterform" styleClass="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="domain"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Domain']}</ui:define>
                        <h:selectOneMenu id="domain" styleClass="form-control gzl-select-text"
                                         value="#{ruleLinkManager.selectedDomain}">
                            <s:selectItems var="domainAvailable"
                                           label="#{domainAvailable}"
                                           value="#{ruleLinkManager.getDomainsAvailable()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="idSchemesForm,rulesForm,filterform"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="it"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                        </ui:define>
                        <h:selectOneMenu id="it" styleClass="form-control gzl-select-text"
                                         value="#{ruleLinkManager.selectedIntegrationProfileName}">
                            <s:selectItems var="iP" label="#{iP}"
                                           value="#{ruleLinkManager.getIntegrationProfilesNames()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="idSchemesForm,rulesForm,filterform"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </h:form>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{ruleLinkManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="col-md-12">
                    <h:form id="rulesForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{ruleLinkManager.getRules().size} filtered rules"/>
                            </ui:define>

                            <rich:dataTable rows="20" id="rules" var="rule"
                                            value="#{ruleLinkManager.getRules()}" render="rulesDs">
                                <g:column sortBy="#{'id'}">
                                    <ui:define name="id">
                                        <h:outputText
                                                value="id"/>
                                    </ui:define>
                                    <h:outputText value="#{rule.id}"
                                                  style="#{ruleLinkManager.getSelectedRule().getId() == rule.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column sortBy="#{'name'}">
                                    <ui:define name="header">
                                        <h:outputText
                                                value="#{messages['net.ihe.gazelle.assertion-manager.Name']}"/>
                                    </ui:define>
                                    <h:outputText value="#{rule.name}"
                                                  style="#{ruleLinkManager.getSelectedRule().getId() == rule.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText
                                                value="##{messages['net.ihe.gazelle.assertion-manager.AssertionsForThisRule']}"/>
                                    </ui:define>
                                    <h:outputText
                                            value="#{ruleLinkManager.getNbAssertionsForThisRule(rule.id)}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText
                                                value="#{messages['net.ihe.gazelle.assertion-manager.SelectRule']}"/>
                                    </ui:define>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                            immdediate="true"
                                            actionListener="#{ruleLinkManager.setSelectedRule(rule)}"
                                            render="rulesForm,idSchemesForm"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="rulesDs"/>
                                        <ui:param name="dataTableId" value="rules"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                            <h:panelGroup rendered="#{ruleLinkManager.isRuleSelected()}">
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">
                                        #{messages['net.ihe.gazelle.assertion-manager.ThisRule']}
                                        (#{ruleLinkManager.getSelectedRule().id})
                                        is linked to the following assertions
                                    </ui:define>
                                    <rich:dataTable rows="20" id="ruleCoverage"
                                                    var="assertionCoverage"
                                                    rendered="#{ruleLinkManager.isRuleSelected()}"
                                                    value="#{ruleLinkManager.assertionsOfSelectedRule()}">
                                        <g:column id="action">
                                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                               rendered="#{ruleLinkManager.isSelectedRuleLinkedTo(assertionCoverage.assertion.id)}"
                                                               actionListener="#{ruleLinkManager.unlinkSelectedRuleFrom(assertionCoverage.assertion.id)}"
                                                               immdediate="true"
                                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                               render="action,ruleCoverage,idSchemesForm"/>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                            </ui:define>
                                            <a4j:commandLink immdediate="true"
                                                             value="#{assertionCoverage.assertion.target.idScheme}"
                                                             actionListener="#{ruleLinkManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                             render="idSchemesForm,filterform"/>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                            </ui:define>
                                            <h:outputLink id="linkAssertion" target="_assertion"
                                                          title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                          value="#{request.contextPath}/assertions/show.seam">
                                                <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                                <h:outputText
                                                        value="#{assertionCoverage.assertion.assertionId}"/>
                                            </h:outputLink>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.Predicate']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{assertionCoverage.assertion.predicate.content}"/>
                                        </g:column>
                                    </rich:dataTable>
                                </ui:decorate>
                            </h:panelGroup>

                        </s:decorate>
                    </h:form>
                </div>
            </ui:define>
            <ui:define name="assertionsLinking">
                <h:form id="idSchemesForm">
                    <ui:include src="../_linkAll.xhtml">
                        <ui:param name="manager" value="#{ruleLinkManager}"/>
                    </ui:include>
                    <rich:dataTable rows="20" id="idScheme" var="assertion"
                                    value="#{ruleLinkManager.assertions}" render="rulesIdSchemeDs">
                        <g:column id="action"
                                  rendered="#{ruleLinkManager.isRuleSelected()}">
                            <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                               disabled="#{!ruleLinkManager.isRuleSelected()}"
                                               rendered="#{not ruleLinkManager.isSelectedRuleLinkedTo(assertion.id) }"
                                               actionListener="#{ruleLinkManager.linkSelectedRuleTo(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                               render="idSchemesForm,ruleCoverage,rulesForm"/>
                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                               disabled="#{!ruleLinkManager.isRuleSelected()}"
                                               rendered="#{ruleLinkManager.isSelectedRuleLinkedTo(assertion.id)}"
                                               actionListener="#{ruleLinkManager.unlinkSelectedRuleFrom(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                               render="idSchemesForm,ruleCoverage,rulesForm"/>
                        </g:column>
                        <ui:include src="../_linkAssertionsTable.xhtml">
                            <ui:param name="assertionParam" value="#{assertion}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="rulesIdSchemeDs"/>
                                <ui:param name="dataTableId" value="idScheme"/>
                                <ui:param name="hideRowsSelect" value="true"/>
                                <ui:param name="maxPages" value="5"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </h:form>
                <ui:include src="../_linkAllPopup.xhtml">
                    <ui:param name="manager" value="#{ruleLinkManager}"/>
                    <ui:param name="formToRender" value="rulesForm"/>
                </ui:include>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
